/*
 *  Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

/*
 * Utilities to monitor system resources.
 */
#include <sys/sysinfo.h>
#include <hyport.h>
#include "OSResourcesMonitor.h"

static unsigned long MEMORYFREETHRESHOLD = 2 * 1024 * 1024; //2M
static unsigned int MEMORYLOADTHRESHOLD = 98; // 98% load

/*
 * Class:     org_apache_harmony_luni_platform_OSResourcesMonitor
 * Method:    isSystemPhysicalMemoryLow
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_org_apache_harmony_luni_platform_OSResourcesMonitor_isSystemPhysicalMemoryLow
  (JNIEnv *env, jclass thizClass)
{
	struct sysinfo info;
	int memoryLoad = 100;		
	if(0 == sysinfo(&info))
	{
	   
	    memoryLoad = 100 - ((float)info.freeram/info.totalram) * 100;
	    if(memoryLoad >= MEMORYLOADTHRESHOLD || info.freeram <= MEMORYFREETHRESHOLD)
	    {
	        return TRUE;
	    }
	}
    return FALSE;	
}
 
